<?php

/* Copyright (C) 2016		 Oscss-Shop       <support@oscss-shop.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 * or see http://www.gnu.org/
 */

Class subCatalog {

    public function __construct(PageConfigSubModule $Master) {

        $this->Master = $Master;

        $this->result = array();

        $this->urlapi = '';

        $this->morecss = array("/admin/dolistore/css/dolistore.css");

        if (file_exists(dol_buildPath('/' . $this->Master->module . '/core/build.json', 0)))
            $build = json_decode(file_get_contents(dol_buildPath('/' . $this->Master->module . '/core/build.json', 0)));
        elseif (file_exists(dol_buildPath('/framework/core/build.json', 0)))
            $build = json_decode(file_get_contents(dol_buildPath('/framework/core/build.json', 0)));

        if (is_object($build)) {
            global $conf;

            // editor
            $this->editor_name = $build->editor->name;
            // For update linked
            $this->urlapi = $build->editor->api;
            $this->Master->api_key = $this->api_key = $build->editor->apikey;

            $this->Master->cstname = "FRAMEWORKAPIKEYLINK" . strtoupper(str_replace(' ', '', trim($this->editor_name)));

            $this->apiregis = new ApiRegistration($build->editor->api, $build->editor->apikey, $conf->global->{$this->Master->cstname});
        }

        dol_include_once('/framework/class/dolistoreoscss.class.php');

        $this->dolistore = new DolistoreOscss($this->apiregis);
    }

    public function PrepareContext() {
        global $langs, $conf, $html, $user, $catalog;

        if (GETPOST("action") == 'redownload' && $user->admin) {
            $descriptor = $this->Master->GetDescriptor(true);

            dol_include_once('/' . $descriptor->code . '/class/updateOscssshop.inc.php');
            $ApiLink = new updateOscssshop($descriptor->code);

            $ApiLink->setServer($descriptor->server);

            $key_editor_link = "FRAMEWORKAPIKEYLINK" . strtoupper(str_replace(' ', '', trim($descriptor->editor_name)));
            $ApiLink->setKey($conf->global->{$key_editor_link});

            $module = GETPOST('module');
            $parent = GETPOST('parent');
            // $redirect = GETPOST('redirect');
            // if($module =='') die();
            if ($parent == '')
                $parent = FALSE;

            $ApiLink->download($module, $parent);
// 				}



            header("Location: " . $_SERVER["PHP_SELF"] . "?page=catalog");
            exit;
        }
    }

    /**
      @brief constructor
     */
    public function DisplayPage() {
        global $langs, $conf, $html, $list, $dolistore, $ListMyAccount, $list2;

        // Translations
        $langs->load("admin");
        $langs->load($this->Master->filelang);

        $dolistore = $this->dolistore;

        $search_greffon = GETPOST('search_greffon'); 
        $search_already = GETPOST('search_already');

//       var_dump($search_greffon); 
//        exit; 
        
        $listmyaccount = $this->apiregis->GetMyAccount();

        $list2 = [];
        foreach ($listmyaccount as $row) {
            $row = (object) $row;

                $ListMyAccount[$row->module] = $row;

                if (  $search_already == 'installed' && isset($conf->{$row->module}))
                    $list2[$row->module] = $row;
                elseif (  $search_already == 'buyed')
                    $list2[$row->module] = $row;

            }


         $listmyaccount = $this->apiregis->GetCatalog();

         foreach ($listmyaccount as $row) {
            $row = (object) $row;

                $view = false; 
                if($search_greffon == 'greffon' && $row->istype =='greffon') 
                    $view = true; 
                elseif($search_greffon == 'nogreffon' && $row->istype =='product') 
                    $view = true; 

                if ( $view  )
                    $list2[$row->reference] = $row;
            }

         
        dol_include_once('/' . $this->Master->module . '/admin/tpl/catalog.tpl');
    }

}
