<?php

trait fixverLoader {

    /**
     * load correction related to versions
     * @fn loadVersionCorss() : void
     */
    function loadVersionCorss() {
//         $this = &self::$instance;
        // sample compare $this->dolv      >= 5.0.0
        // sample compare $this->shortdolv >= 5.0
        // sample compare $this->maindolv  >= 1
        if (version_compare($this->dolv, '5.0.0', '>=')) {
            // sample usage
            $this->type('order')->class = 'Commande';
        }
    }

    /**
     * Load initial values of fiver
     * @fn loadDefaultCorss() : void
     */
    function loadDefaultCorss() {
//         $this = &self::$instance;

        // Agenda
        $tmpchild                = new fvChild('agenda');
        $tmpchild->class         = 'ActionComm';
        $tmpchild->table         = 'actioncomm';
        $tmpchild->datefieldname = 'datep';
        $tmpchild->setPathAndRelated('comm/action/');
        $this->corss[]             = $tmpchild;

        // Contact
        $tmpchild         = new fvChild('contact');
        $tmpchild->table  = 'socpeople';
        $tmpchild->lang   = 'company';
        $tmpchild->tights = 'societe->contact';
        $tmpchild->conf   = 'societe';
        $this->corss[]      = $tmpchild;

        // Contact
        $tmpchild                = new fvChild('contract');
        $tmpchild->name          = 'Contracts';
        $tmpchild->title         = "ListContractAssociatedQualityreport";
        $tmpchild->datefieldname = 'date_contrat';
        $tmpchild->conf          = 'contrat';
        $this->corss[]             = $tmpchild;

        // Delivery
        $tmpchild          = new fvChild('livraison');
        $tmpchild->type    = 'delivery';
        $tmpchild->element    = 'delivery';
        $tmpchild->oldtype = 'livraison';
        $tmpchild->conf    = 'expedition';
        $tmpchild->rights  = 'expedition->livraison';
        $tmpchild->nameid  = 'rowid';
        $tmpchild->lang    = 'shipping';
        $tmpchild->setPathAndRelated('livraison/');
        $this->corss[]       = $tmpchild;

        // Donation
        $tmpchild                = new fvChild('donation');
        $tmpchild->class         = 'Don';
        $tmpchild->table         = 'don';
        $tmpchild->datefieldname = 'datedon';
        $tmpchild->margin        = 'add';
        $tmpchild->rights        = 'don';
        $tmpchild->lang          = 'donations';
        $tmpchild->setPathAndRelated('don/');
        $this->corss[]             = $tmpchild;

        // Expensereport
        $tmpchild                = new fvChild('expensereport');
        $tmpchild->name          = 'ExpenseReports';
        $tmpchild->title         = 'ExpenseReports';
        $tmpchild->class         = 'ExpenseReportLine';
        $tmpchild->table         = 'expensereport_det';
        $tmpchild->datefieldname = 'date';
        $tmpchild->disableamount = 0;
        $tmpchild->lang          = 'trips';
        $this->corss[]             = $tmpchild;

        // Fichinter
        $tmpchild                = new fvChild('fichinter');
        $tmpchild->datefieldname = 'date_valid';
        $tmpchild->lang          = 'interventions';
        $this->corss[]             = $tmpchild;

        // Group
        $tmpchild                = new fvChild('group');
        $tmpchild->name          = 'Groups';
        $tmpchild->class         = 'UserGroup';
        $tmpchild->table         = 'usergroup';
        $tmpchild->datefieldname = 'datep';
        $tmpchild->lang          = 'usergroup';
        $this->corss[]             = $tmpchild;

        // Invoice
        $tmpchild                = new fvChild('invoice');
        $tmpchild->name          = 'CustomersInvoices';
        $tmpchild->class         = 'Facture';
        $tmpchild->table         = 'facture';
        $tmpchild->datefieldname = 'datef';
        $tmpchild->lang          = 'bills';
        $tmpchild->rights        = 'facture';
        $tmpchild->conf          = 'facture';
        $tmpchild->oldtype       = 'facture';
        $tmpchild->setPathAndRelated('compta/facture/');
        $this->corss[]             = $tmpchild;

        // Invoice supplier
        $tmpchild                = new fvChild('invoice_supplier');
        $tmpchild->name          = 'BillsSuppliers';
        $tmpchild->class         = 'FactureFournisseur';
        $tmpchild->fileclass         = 'fournisseur.facture';
        $tmpchild->table         = 'facture_fourn';
        $tmpchild->datefieldname = 'datef';
        $tmpchild->lang          = 'suppliers';
        $tmpchild->conf          = 'facturefournisseur';
        $tmpchild->setPathAndRelated('fourn/');
        $this->corss[]             = $tmpchild;

        // Invoice predefined
        $tmpchild        = new fvChild('invoice_predefined');
        $tmpchild->name  = 'PredefinedInvoices';
        $tmpchild->class = 'FactureRec';
        $tmpchild->table = 'facture_rec';
        $tmpchild->lang  = 'bills';
        $tmpchild->path  = 'compta/facture/';
        $tmpchild->list  = 'compta/facture/invoicetemplate_list.php';
        $tmpchild->card  = 'compta/facture/card-rec.php';
        $tmpchild->id    = 'facid';
        $this->corss[]     = $tmpchild;

        // order
        $tmpchild                = new fvChild('order');
        $tmpchild->name          = 'CustomersOrders';
        $tmpchild->class         = 'Commande';
        $tmpchild->table         = 'commande';
        $tmpchild->datefieldname = 'date_commande';
        $tmpchild->lang          = 'orders';
        $tmpchild->oldtype       = 'commande';
        $tmpchild->conf          = 'commande';
        $tmpchild->setPathAndRelated('commande/');
        $this->corss[]             = $tmpchild;

        // order supplier
        $tmpchild                = new fvChild('order_supplier');
        $tmpchild->name          = 'SuppliersOrders';
        $tmpchild->class         = 'CommandeFournisseur';
        $tmpchild->table         = 'commande_fournisseur';
        $tmpchild->datefieldname = 'date_commande';
        $tmpchild->lang          = 'suppliers';
        $tmpchild->tabs          = 'supplier_order';
        $tmpchild->conf          = 'supplier_order';
        $tmpchild->setPathAndRelated('fourn/commande/');
        $this->corss[]             = $tmpchild;

        // propal
        $tmpchild                = new fvChild('propal');
        $tmpchild->name          = 'Proposals';
        $tmpchild->datefieldname = 'datep';
        $tmpchild->lang          = 'propal';
        $tmpchild->setPathAndRelated('comm/propal/');
        $this->corss[]             = $tmpchild;

        // proposal supplier
        $tmpchild                = new fvChild('proposal_supplier');
        $tmpchild->name          = 'SuppliersProposals';
        $tmpchild->table         = 'supplier_proposal';
        $tmpchild->datefieldname = 'date';
        $tmpchild->lang          = 'supplier_proposal';
        $tmpchild->conf          = 'supplierproposal';
        $tmpchild->setPathAndRelated('supplier_proposal/');
        $this->corss[]             = $tmpchild;

        // product
        $tmpchild        = new fvChild('product');
        $tmpchild->title = 'Products';
        $this->corss[]     = $tmpchild;

        // project
        $tmpchild          = new fvChild('project');
        $tmpchild->name    = 'Projet';
        $tmpchild->table   = 'projet';
        $tmpchild->rights  = 'projet';
        $tmpchild->oldtype = 'projet';
        $tmpchild->lang    = 'projects';
        $tmpchild->conf    = 'projet';
        $tmpchild->setPathAndRelated('projet/');
        $this->corss[]       = $tmpchild;

        // shipping
        $tmpchild                = new fvChild('shipping');
        $tmpchild->class         = 'Expedition';
        $tmpchild->table         = 'expedition';
        $tmpchild->datefieldname = 'datep';
        $tmpchild->tabs          = 'expedition';
        $tmpchild->rights        = 'expedition';
        $tmpchild->nameid        = 'rowid';
        $tmpchild->oldtype       = 'expedition';
        $tmpchild->setPathAndRelated('expedition/');
        $this->corss[]             = $tmpchild;

        // shipping
        $tmpchild         = new fvChild('ticket');
        $tmpchild->nameid = 'rowid';
        $this->corss[]      = $tmpchild;

        // Thirdparty
        $tmpchild                = new fvChild('thirdparty');
        $tmpchild->class         = 'Societe';
        $tmpchild->table         = 'societe';
        $tmpchild->datefieldname = 'datep';
        $tmpchild->rights        = 'societe';
        $tmpchild->nameid        = 'socid';
        $tmpchild->lang          = 'company';
        $tmpchild->oldtype       = 'societe';
        $tmpchild->conf          = 'societe';
        $tmpchild->setPathAndRelated('societe/');
        $this->corss[]             = $tmpchild;

        // Trip
        $tmpchild                = new fvChild('trip');
        $tmpchild->name          = 'TripsAndExpenses';
        $tmpchild->title         = 'TripsAndExpenses';
        $tmpchild->class         = 'Deplacement';
        $tmpchild->table         = 'deplacement';
        $tmpchild->datefieldname = 'dated';
        $tmpchild->rights        = 'deplacement';
        $tmpchild->lang          = 'trips';
        $tmpchild->setPathAndRelated('deplacement/');
        $this->corss[]             = $tmpchild;

        // user
        $tmpchild                = new fvChild('user');
        $tmpchild->name          = 'Users';
        $tmpchild->datefieldname = 'datep';
        $this->corss[]             = $tmpchild;
    }

}
