<?php 
/* Copyright (C) 2016		 Oscss-Shop       <support@oscss-shop.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 * or see http://www.gnu.org/
 */



if(!function_exists('completeFileArrayWithDatabaseInfo') ){
/**
 * Complete $filearray with data from database.
 * This will call doldir_list_indatabase to complate filearray.
 *
 * @param	array	$filearray			Array of files get using dol_dir_list
 * @param	string	$relativedir		Relative dir from DOL_DATA_ROOT
 * @return	void
 */
function completeFileArrayWithDatabaseInfo(&$filearray, $relativedir)
{
	global $conf, $db, $user;

	$filearrayindatabase = dol_dir_list_in_database($relativedir, '', null, 'name', SORT_ASC);

	// TODO Remove this when PRODUCT_USE_OLD_PATH_FOR_PHOTO will be removed
	global $modulepart;
	if ($modulepart == 'produit' && ! empty($conf->global->PRODUCT_USE_OLD_PATH_FOR_PHOTO)) {
		global $object;
		if (! empty($object->id))
		{
			if (! empty($conf->product->enabled)) $upload_dirold = $conf->product->multidir_output[$object->entity].'/'.substr(substr("000".$object->id, -2),1,1).'/'.substr(substr("000".$object->id, -2),0,1).'/'.$object->id."/photos";
			else $upload_dirold = $conf->service->multidir_output[$object->entity].'/'.substr(substr("000".$object->id, -2),1,1).'/'.substr(substr("000".$object->id, -2),0,1).'/'.$object->id."/photos";

			$relativedirold = preg_replace('/^'.preg_quote(DOL_DATA_ROOT,'/').'/', '', $upload_dirold);
			$relativedirold = preg_replace('/^[\\/]/','',$relativedirold);

			$filearrayindatabase = array_merge($filearrayindatabase, dol_dir_list_in_database($relativedirold, '', null, 'name', SORT_ASC));
		}
	}

	//var_dump($filearray);
	//var_dump($filearrayindatabase);

	// Complete filearray with properties found into $filearrayindatabase
	foreach($filearray as $key => $val)
	{
		$found=0;
		// Search if it exists into $filearrayindatabase
		foreach($filearrayindatabase as $key2 => $val2)
		{
			if ($filearrayindatabase[$key2]['name'] == $filearray[$key]['name'])
			{
				$filearray[$key]['position_name']=($filearrayindatabase[$key2]['position']?$filearrayindatabase[$key2]['position']:'0').'_'.$filearrayindatabase[$key2]['name'];
				$filearray[$key]['position']=$filearrayindatabase[$key2]['position'];
				$filearray[$key]['cover']=$filearrayindatabase[$key2]['cover'];
				$filearray[$key]['acl']=$filearrayindatabase[$key2]['acl'];
				$filearray[$key]['rowid']=$filearrayindatabase[$key2]['rowid'];
				$filearray[$key]['label']=$filearrayindatabase[$key2]['label'];
				$found=1;
				break;
			}
		}

		if (! $found)    // This happen in transition toward version 6, or if files were added manually into os dir.
		{
			$filearray[$key]['position']='999999';     // File not indexed are at end. So if we add a file, it will not replace an existing position
			$filearray[$key]['cover']=0;
			$filearray[$key]['acl']='';

			$rel_filename = preg_replace('/^'.preg_quote(DOL_DATA_ROOT,'/').'/', '', $filearray[$key]['fullname']);
			if (! preg_match('/([\\/]temp[\\/]|[\\/]thumbs|\.meta$)/', $rel_filetorenameafter))     // If not a tmp file
			{
				dol_syslog("list_of_documents We found a file called '".$filearray[$key]['name']."' not indexed into database. We add it");
				include_once DOL_DOCUMENT_ROOT.'/ecm/class/ecmfiles.class.php';
				$ecmfile=new EcmFiles($db);

				// Add entry into database
				$filename = basename($rel_filename);
				$rel_dir = dirname($rel_filename);
				$rel_dir = preg_replace('/[\\/]$/', '', $rel_dir);
				$rel_dir = preg_replace('/^[\\/]/', '', $rel_dir);

				$ecmfile->filepath = $rel_dir;
				$ecmfile->filename = $filename;
				$ecmfile->label = md5_file(dol_osencode($filearray[$key]['fullname']));        // $destfile is a full path to file
				$ecmfile->fullpath_orig = $filearray[$key]['fullname'];
				$ecmfile->gen_or_uploaded = 'unknown';
				$ecmfile->description = '';    // indexed content
				$ecmfile->keyword = '';        // keyword content
				$result = $ecmfile->create($user);
				if ($result < 0)
				{
					setEventMessages($ecmfile->error, $ecmfile->errors, 'warnings');
				}
				else
				{
					$filearray[$key]['rowid']=$result;
				}
			}
			else
			{
				$filearray[$key]['rowid']=0;     // Should not happened
			}
		}
	}

	/*var_dump($filearray);*/
}


}

	
	
