<?php
/* Copyright (C) 2007-2017 Laurent Destailleur  <eldy@users.sourceforge.net>
 * Copyright (C) ---Put here your own copyright and developer email---
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * \file    test/unit/fixversionTest.php
 * \ingroup logistics
 * \brief   PHPUnit test for fixversion class.
 */

namespace test\unit;

global $conf,$user,$langs,$db;
require_once dirname(__FILE__).'/../../../../master.inc.php';
require_once dirname(__FILE__).'/../../class/fixversion.class.php';

if (empty($user->id)) {
    print "Load permissions for admin user nb 1\n";
    $user->fetch(1);
    $user->getrights();
}
$conf->global->MAIN_DISABLE_ALL_MAILS=1;


/**
 * Class fixversionTest
 * @package Testlogistics
 */
class fixversionTest extends \PHPUnit_Framework_TestCase
{
    protected $savconf;
    protected $savuser;
    protected $savlangs;
    protected $savdb;

    /**
     * Constructor
     * We save global variables into local variables
     *
     * @return fixversionTest
     */
    public function __construct($name = NULL, array $data = array(), $dataName = '') {
		parent::__construct($name, $data, $dataName);

    	//$this->sharedFixture
        global $conf,$user,$langs,$db;
        $this->savconf=$conf;
        $this->savuser=$user;
        $this->savlangs=$langs;
        $this->savdb=$db;

        print __METHOD__." db->type=".$db->type." user->id=".$user->id;
        //print " - db ".$db->db;
        print "\n";
    }

    // Static methods
    public static function setUpBeforeClass()
    {
        global $conf,$user,$langs,$db;
//         $db->begin(); // This is to have all actions inside a transaction even if test launched without suite.


        if (empty($conf->framework->enabled)) { print __METHOD__." module framework order must be enabled.\n"; 

        die(); }

        print __METHOD__."\n";
    }

    // tear down after class
    public static function tearDownAfterClass()
    {
        global $conf,$user,$langs,$db;
//         $db->rollback();

        print __METHOD__."\n";
    }
    /**
     * testfixversionCreate
     *
     * @return  void
     */
    public function testfixversionNewObject()
    {
        global $conf,$user,$langs,$db;
        $conf=$this->savconf;
        $user=$this->savuser;
        $langs=$this->savlangs;
        $db=$this->savdb;

        $localobject=new \fixversion($db);
		
		$this->assertTrue(true);

        print __METHOD__." result=".$result."\n";
        return $localobject;
    }

    /**
     * testfixversionCreate
     *
     * @return  void
     * @depends	testfixversionNewObject
     * The depends says test is run only if previous is ok
     */
    public function testfixversionGetTypeByClassName($localobject)
    {
        global $conf,$user,$langs,$db;
        $conf=$this->savconf;
        $user=$this->savuser;
        $langs=$this->savlangs;
        $db=$this->savdb;

//         $localobject=new \fixversion($db);
		
		foreach($localobject->corss as $type=>$row){
			$result = $localobject->GetTypeByClassName($row['class']);
			$this->assertEquals($result, $type);
	
		}

        print __METHOD__." result=".$result."\n";
        return $localobject;
    }

    
    /**
     * testfixversionCreate
     *
     * @return  void
     * @depends	testfixversionNewObject
     * The depends says test is run only if previous is ok
     */
    public function testfixversionGetPathByClassName($localobject)
    {
        global $conf,$user,$langs,$db;
        $conf=$this->savconf;
        $user=$this->savuser;
        $langs=$this->savlangs;
        $db=$this->savdb;

	
		foreach($localobject->corss as $type=>$row){
			
			$result = $localobject->GetPathByClassName($row['class']);
			$this->assertEquals($result, $row['path']);
			
		}

        print __METHOD__." result=".$result."\n";
        return $result;
    }
    
    
	/**
	 * Unit test setup
     * @return void
	 */
	protected function setUp()
	{
        global $conf,$user,$langs,$db;
        $conf=$this->savconf;
        $user=$this->savuser;
        $langs=$this->savlangs;
        $db=$this->savdb;

        print __METHOD__."\n";
	}

	/**
	 * Verify pre conditions
     * @return void
	 */
	protected function assertPreConditions()
	{
		fwrite(STDOUT, __METHOD__ . "\n");
	}

	/**
	 * A sample test
     * @return bool
	 */
	public function testSomething()
	{
		fwrite(STDOUT, __METHOD__ . "\n");
		// TODO: test something
// 		$this->assertTrue(true);
	}

	/**
	 * Verify post conditions
     * @return void
	 */
	protected function assertPostConditions()
	{
		fwrite(STDOUT, __METHOD__ . "\n");
	}

	/**
	 * Unit test teardown
     * @return void
	 */
	protected function tearDown()
	{
		fwrite(STDOUT, __METHOD__ . "\n");
	}


	/**
	 * Unsuccessful test
	 *
	 * @param  Exception $e    Exception
     * @return void
	 * @throws Exception
	 */
// 	protected function onNotSuccessfulTest(Exception $e)
// 	{
// 		fwrite(STDOUT, __METHOD__ . "\n");
// 		throw $e;
// 	}
}
